
`timescale 1ps / 1ps

module decoder_3to8 (dec_in, dec_out);
  input [2:0] dec_in;
  output [7:0] dec_out;

  wire [2:0] dec_in;
  wire [7:0] dec_out;
  
  function [7:0] decoder_3to8_impl;
    input [2:0] dec_in2;

    case (dec_in2)

      // 0
      3'b000: begin
        decoder_3to8_impl = 8'b01111111;
      end

      // 1
      3'b001: begin
        decoder_3to8_impl = 8'b10111111;
      end

      // 2
      3'b010: begin
        decoder_3to8_impl = 8'b11011111;
      end

      // 3
      3'b011: begin
        decoder_3to8_impl = 8'b11101111;
      end

      // 4
      3'b100: begin
        decoder_3to8_impl = 8'b11110111;
      end

      // 5
      3'b101: begin
        decoder_3to8_impl = 8'b11111011;
      end

      // 6
      3'b110: begin
        decoder_3to8_impl = 8'b11111101;
      end

      // 7
      3'b111: begin
        decoder_3to8_impl = 8'b11111110;
      end

      default: begin
      end

    endcase

  endfunction

  assign dec_out = decoder_3to8_impl (dec_in);

endmodule
