
`timescale 1ps / 1ps

module key_detector (clk, key, stb_in);
  input clk;
  input [9:0] key;
  output stb_in;

  wire clk;
  wire [9:0] key;
  reg stb_in;
  
  reg [9:0] prev_key;
  wire key_in;

  assign key_in = ((key != 0) && (key != prev_key));

  always
    @(posedge clk) begin
      if (key_in) begin
        stb_in <= 1;
      end
      else begin
        stb_in <= 0;
      end
      prev_key <= key;
    end
  
endmodule
