
`timescale 1ps / 1ps

module key_reg (clk, reset_n, stb_in, key_in, key_a, key_b, key_c, key_d,
  key_comp);

  input clk;
  input reset_n;
  input stb_in;
  input [3:0] key_in;
  output [3:0] key_a;
  output [3:0] key_b;
  output [3:0] key_c;
  output [3:0] key_d;
  output key_comp;

  wire clk;
  wire reset_n;
  wire stb_in;
  wire [3:0] key_in;

  reg [3:0] key_a;
  reg [3:0] key_b;
  reg [3:0] key_c;
  reg [3:0] key_d;

  reg [4:0] key_count;
  wire [4:0] key_count_next;

  assign key_count_next = (key_count << 1);
  assign key_comp = (key_count_next == 0);

  always
    @(posedge clk or negedge reset_n) begin
      if (~reset_n) begin
        key_a <= 4'b1101;
        key_b <= 4'b1101;
        key_c <= 4'b1101;
        key_d <= 4'b1101;
        key_count <= 4'b0001;
      end
      else if (stb_in) begin
        key_a <= key_b;
        key_b <= key_c;
        key_c <= key_d;
        key_d <= key_in;
        key_count <= key_count_next;
        if (key_comp) begin
          key_a <= 4'b1101;
          key_b <= 4'b1101;
          key_c <= 4'b1101;
          key_count <= 4'b0010;
        end
      end
    end

endmodule
