
`timescale 1ps / 1ps

module main (key_comp, key_a, key_b, key_c, key_d, hrkey_a, hrkey_b, hrkey_c,
  hrkey_d, seg_a, seg_b, seg_c, seg_d, seg_e, seg_f, seg_g, seg_h);

  input key_comp;
  input [3:0] key_a;
  input [3:0] key_b;
  input [3:0] key_c;
  input [3:0] key_d;
  input [3:0] hrkey_a;
  input [3:0] hrkey_b;
  input [3:0] hrkey_c;
  input [3:0] hrkey_d;

  output [3:0] seg_a;
  output [3:0] seg_b;
  output [3:0] seg_c;
  output [3:0] seg_d;
  output [3:0] seg_e;
  output [3:0] seg_f;
  output [3:0] seg_g;
  output [3:0] seg_h;

  wire key_comp;
  wire [3:0] key_a;
  wire [3:0] key_b;
  wire [3:0] key_c;
  wire [3:0] key_d;
  wire [3:0] hrkey_a;
  wire [3:0] hrkey_b;
  wire [3:0] hrkey_c;
  wire [3:0] hrkey_d;

  wire [3:0] seg_a;
  wire [3:0] seg_b;
  wire [3:0] seg_c;
  wire [3:0] seg_d;
  wire [3:0] seg_e;
  wire [3:0] seg_f;
  wire [3:0] seg_g;
  wire [3:0] seg_h;

  wire comp_aa;
  wire comp_ab;
  wire comp_ac;
  wire comp_ad;
  wire comp_ba;
  wire comp_bb;
  wire comp_bc;
  wire comp_bd;
  wire comp_ca;
  wire comp_cb;
  wire comp_cc;
  wire comp_cd;
  wire comp_da;
  wire comp_db;
  wire comp_dc;
  wire comp_dd;
  wire comp_a_out;
  wire comp_b_out;
  wire comp_c_out;
  wire comp_d_out;

  assign comp_aa = (key_a == hrkey_a);
  assign comp_ab = (key_a == hrkey_b);
  assign comp_ac = (key_a == hrkey_c);
  assign comp_ad = (key_a == hrkey_d);
  assign comp_ba = (key_b == hrkey_a);
  assign comp_bb = (key_b == hrkey_b);
  assign comp_bc = (key_b == hrkey_c);
  assign comp_bd = (key_b == hrkey_d);
  assign comp_ca = (key_c == hrkey_a);
  assign comp_cb = (key_c == hrkey_b);
  assign comp_cc = (key_c == hrkey_c);
  assign comp_cd = (key_c == hrkey_d);
  assign comp_da = (key_d == hrkey_a);
  assign comp_db = (key_d == hrkey_b);
  assign comp_dc = (key_d == hrkey_c);
  assign comp_dd = (key_d == hrkey_d);

  assign comp_a_out = ((!comp_aa) && (!comp_ab) && (!comp_ac) &&
    (!comp_ad));
  assign comp_b_out = ((!comp_ba) && (!comp_bb) && (!comp_bc) &&
    (!comp_bd));
  assign comp_c_out = ((!comp_ca) && (!comp_cb) && (!comp_cc) &&
    (!comp_cd));
  assign comp_d_out = ((!comp_da) && (!comp_db) && (!comp_dc) &&
    (!comp_dd));

  wire [3:0] dummy_num;
  wire [3:0] strike_num;
  wire [3:0] ball_num;
  wire [3:0] out_num;

  wire homerun;

  assign seg_a = key_a;
  assign seg_b = key_b;
  assign seg_c = key_c;
  assign seg_d = key_d;

  function [3:0] count_strike;

    input comp_aa2;
    input comp_bb2;
    input comp_cc2;
    input comp_dd2;

    begin: count_strike2

      count_strike = 0;

      if (comp_aa2) begin
        count_strike = count_strike + 1;
      end

      if (comp_bb2) begin
        count_strike = count_strike + 1;
      end

      if (comp_cc2) begin
        count_strike = count_strike + 1;
      end

      if (comp_dd2) begin
        count_strike = count_strike + 1;
      end

    end

  endfunction

  function [3:0] count_ball;

    input comp_ab2;
    input comp_ac2;
    input comp_ad2;
    input comp_ba2;
    input comp_bc2;
    input comp_bd2;
    input comp_ca2;
    input comp_cb2;
    input comp_cd2;
    input comp_da2;
    input comp_db2;
    input comp_dc2;

    begin: count_ball2

      count_ball = 0;

      if (comp_ab2) begin
        count_ball = count_ball + 1;
      end

      if (comp_ac2) begin
        count_ball = count_ball + 1;
      end

      if (comp_ad2) begin
        count_ball = count_ball + 1;
      end

      if (comp_ba2) begin
        count_ball = count_ball + 1;
      end

      if (comp_bc2) begin
        count_ball = count_ball + 1;
      end

      if (comp_bd2) begin
        count_ball = count_ball + 1;
      end

      if (comp_ca2) begin
        count_ball = count_ball + 1;
      end

      if (comp_cb2) begin
        count_ball = count_ball + 1;
      end

      if (comp_cd2) begin
        count_ball = count_ball + 1;
      end

      if (comp_da2) begin
        count_ball = count_ball + 1;
      end

      if (comp_db2) begin
        count_ball = count_ball + 1;
      end

      if (comp_dc2) begin
        count_ball = count_ball + 1;
      end

    end

  endfunction

  function [3:0] count_out;

    input comp_a_out2;
    input comp_b_out2;
    input comp_c_out2;
    input comp_d_out2;

    begin: count_out2

      count_out = 0;

      if (comp_a_out2) begin
        count_out = count_out + 1;
      end

      if (comp_b_out2) begin
        count_out = count_out + 1;
      end

      if (comp_c_out2) begin
        count_out = count_out + 1;
      end

      if (comp_d_out2) begin
        count_out = count_out + 1;
      end

    end

  endfunction

  assign dummy_num = 4'b1101;
  assign strike_num = count_strike(comp_aa, comp_bb, comp_cc, comp_dd);
  assign ball_num = count_ball(comp_ab, comp_ac, comp_ad, comp_ba, comp_bc,
    comp_bd, comp_ca, comp_cb, comp_cd, comp_da, comp_db, comp_dc);
  assign out_num = count_out(comp_a_out, comp_b_out, comp_c_out, comp_d_out);
  assign homerun = (strike_num == 4);

  function [3:0] display_num;

    input [3:0] num1;
    input [3:0] num2;
    input key_comp2;
    input homerun2;

    if (key_comp2) begin
      if (homerun2) begin
        display_num = num2;
      end
      else begin
        display_num = num1;
      end
    end
    else begin
      display_num = 4'b1101;
    end

  endfunction

  assign seg_e = display_num (dummy_num, 4'b1010, key_comp, homerun);
  assign seg_f = display_num (strike_num, 4'b1011, key_comp, homerun);
  assign seg_g = display_num (ball_num, 4'b1011, key_comp, homerun);
  assign seg_h = display_num (out_num, 4'b1100, key_comp, homerun);

endmodule
