
`timescale 1ps / 1ps

module seg_decoder (seg_in, seg_out);
  input [3:0] seg_in;
  output [6:0] seg_out;

  wire [3:0] seg_in;
  wire [6:0] seg_out;
  
  function [6:0] seg_decoder_impl;
    input [3:0] seg_in2;

    case (seg_in2)

      // 0
      4'b0000: begin
        seg_decoder_impl = 7'b1111110;
      end

      // 1
      4'b0001: begin
        seg_decoder_impl = 7'b0000110;
      end

      // 2
      4'b0010: begin
        seg_decoder_impl = 7'b1101101;
      end

      // 3
      4'b0011: begin
        seg_decoder_impl = 7'b1111001;
      end

      // 4
      4'b0100: begin
        seg_decoder_impl = 7'b0110011;
      end

      // 5
      4'b0101: begin
        seg_decoder_impl = 7'b1011011;
      end

      // 6
      4'b0110: begin
        seg_decoder_impl = 7'b1011111;
      end

      // 7
      4'b0111: begin
        seg_decoder_impl = 7'b1110010;
      end

      // 8
      4'b1000: begin
        seg_decoder_impl = 7'b1111111;
      end

      // 9
      4'b1001: begin
        seg_decoder_impl = 7'b1111011;
      end

      // g
      4'b1010: begin
        seg_decoder_impl = 7'b1011110;
      end

      // o
      4'b1011: begin
        seg_decoder_impl = 7'b0011101;
      end

      // d
      4'b1100: begin
        seg_decoder_impl = 7'b0111101;
      end

      // nothing
      4'b1101: begin
        seg_decoder_impl = 7'b0000000;
      end

      // e
      default: begin
        seg_decoder_impl = 7'b1001111;
      end

    endcase

  endfunction

  assign seg_out = seg_decoder_impl (seg_in);

endmodule
