`timescale 1ps / 1ps

module seg_driver (clk, seg_a, seg_b, seg_c, seg_d, seg_e, seg_f, seg_g, seg_h,
  seg_out, seg_sel);

  input clk;
  input [3:0] seg_a;
  input [3:0] seg_b;
  input [3:0] seg_c;
  input [3:0] seg_d;
  input [3:0] seg_e;
  input [3:0] seg_f;
  input [3:0] seg_g;
  input [3:0] seg_h;
  output [6:0] seg_out;
  output [7:0] seg_sel;

  wire clk;
  wire [3:0] seg_a;
  wire [3:0] seg_b;
  wire [3:0] seg_c;
  wire [3:0] seg_d;
  wire [3:0] seg_e;
  wire [3:0] seg_f;
  wire [3:0] seg_g;
  wire [3:0] seg_h;
  reg [6:0] seg_out;
  reg [7:0] seg_sel;

  wire [6:0] seg_out2;
  reg [2:0] seg_sel2;
  wire [2:0] seg_sel2_next;
  wire [7:0] seg_sel3;

  wire [7:0] seg_1;
  wire [7:0] seg_2;
  wire [7:0] seg_3;
  wire [7:0] seg_4;

  wire [3:0] seg__2;

  assign seg_1 = {seg_a[3], seg_b[3], seg_c[3], seg_d[3], seg_e[3], seg_f[3],
    seg_g[3], seg_h[3]};
  assign seg_2 = {seg_a[2], seg_b[2], seg_c[2], seg_d[2], seg_e[2], seg_f[2],
    seg_g[2], seg_h[2]};
  assign seg_3 = {seg_a[1], seg_b[1], seg_c[1], seg_d[1], seg_e[1], seg_f[1],
    seg_g[1], seg_h[1]};
  assign seg_4 = {seg_a[0], seg_b[0], seg_c[0], seg_d[0], seg_e[0], seg_f[0],
    seg_g[0], seg_h[0]};
  
  assign seg_sel2_next = (seg_sel2 + 1);

  decoder_3to8 decoder1 (seg_sel2, seg_sel3);
  mux_8to1 mux1 (seg_1, seg_sel2, seg__2[3]);
  mux_8to1 mux2 (seg_2, seg_sel2, seg__2[2]);
  mux_8to1 mux3 (seg_3, seg_sel2, seg__2[1]);
  mux_8to1 mux4 (seg_4, seg_sel2, seg__2[0]);
  seg_decoder seg_decoder1 (seg__2, seg_out2);

  always
    @(posedge clk) begin
      seg_sel <= seg_sel3;
      seg_out <= seg_out2;
      seg_sel2 <= seg_sel2_next;
    end

endmodule
